unit progmenu;
{
Menu execution library
Made by Xaver Bauer <xb@condat.com>

}

interface
uses ifspas, ifs_var, Menus;

procedure RegisterProgramMenu(p: TIfPasScript; M: TMenuItem);

implementation

CONST
  Menu : tMenuItem = nil;

function findMenu(Name:String):tMenuItem;
var s,m:String; j:Integer;
Begin
  j:=Pos('.',Name); m:='';
  if j>0 Then Begin
    s:=copy(Name,1,j-1);
    m:=copy(Name,j+1,Length(Name));
  End else s:=Name;
  result:=Menu.Find(S);
  if (Result<>nil) and (m>'') Then
    Result:=Result.Find(m);
End;

function MenuProc(Sender: TIfPasScript; ScriptID: Pointer; proc: PProcedure; Params: PVariableManager; res: PIfVariant): TIfPasScriptError;
var s:String; m:tMenuItem;
begin
 if proc^.Name = 'EXECMENU' then begin
   if not Assigned(Menu) Then
   Begin
     Sender.RunError2( Sender, ECustomError, 'Men nicht zugewiesen!');
     MenuProc:=ECustomError;
     Exit;
   end;
   s:=GetString(Vm_Get(Params, 0));
   m:=findMenu(s);
   if Assigned(m) and m.Enabled Then
     if Assigned(m.Action) Then m.Action.Execute
     else if Assigned(m.OnClick) Then m.OnClick(m);
  end;
  Result:=ENoError;
end;

procedure RegisterProgramMenu(p: TIfPasScript; M: tMenuItem);
begin
  p.AddFunction(@MenuProc, 'procedure ExecMenu(s: string)', nil);
  Menu:=M;
end;


end.
 