unit typecast;
{
  Innerfuse Pascal Script Library
  For license see Innerfuse Pascal Script license file

  Library Written By: Adel Samuel
  E-mail At: adelsamuel@sympatico.ca
  Version 0.5 (Test Version)
}
{$I LB_DEF.INC}
interface

uses
  ifspas, ifs_var, ifs_utl;

procedure AddTypeCasting(p: TIfPasScript);

implementation

function CastProc(Sender: TIfPasScript; ScriptID: Pointer; Proc: PProcedure;
  Params: PVariableManager; res: PIfVariant): TIfPasScriptError;
begin
  CastProc := ENoError;
  if (Proc^.Name = 'INTEGER') or (Proc^.Name = 'LONGINT') or (Proc^.Name =
    'WORD')
    or (Proc^.Name = 'SMALLINT') or (Proc^.Name = 'CARDINAL') or (Proc^.Name =
    'BYTE') then
  begin
    case GetVarLink(VM_GET(Params, 0)).CV_Variant.VType.atypeid of
      CSV_UByte: // Byte
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UByte));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SByte: // Shortint
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SByte));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt16: // Word
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt16));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt16: // SmallInt
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt16));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt32: // Cardinal
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt32: // Longint
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Char: // Char
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Char));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_String: // String
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Str));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Real: // Real
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Single: // Single
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Double: // Single
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Extended: // Double
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Bool: // Boolean
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Bool));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Array: // Boolean
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_ArrItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Record: // Boolean
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_RecItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Class: // Boolean
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Class));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
{$IFNDEF NOPOINTERS}
      CSV_Internal: // Pointer
        begin
          try
            SetInteger(Res, Integer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.Cv_Int1));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end
{$ENDIF}
    else
      begin
        CastProc := ECustomError;
        Sender.RunError2(Sender, ECustomError, 'Type unsupported');
      end;
    end;
  end
  else
    if (Proc^.Name = 'STRING') or (Proc^.Name = 'CHAR') then
  begin
    case GetVarLink(VM_GET(Params, 0)).CV_Variant.VType.atypeid of
      CSV_UByte: // Byte
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_SByte: // Shortint
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_UInt16: // Word
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_SInt16: // SmallInt
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_UInt32: // Cardinal
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt32: // Longint
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Char: // Char
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Char));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_String: // String
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Str));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Real: // Real
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Single: // Single
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Double: // Double
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Extended: // Extended
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Bool: // Boolean
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Array: // Array
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_ArrItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Record: // Record
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_RecItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Class: // Class
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Class));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
{$IFNDEF NOPOINTERS}
      CSV_Internal: // Pointer
        begin
          try
            SetString(Res, string(GetVarLink(VM_GET(Params,
              0)).CV_Variant.Cv_Int1));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end
{$ENDIF}
    else
      begin
        CastProc := ECustomError;
        Sender.RunError2(Sender, ECustomError, 'Type unsupported');
      end;
    end;
  end
  else
    if (Proc^.Name = 'BOOLEAN') or (Proc^.Name = 'BOOL') then
  begin
    case GetVarLink(VM_GET(Params, 0)).CV_Variant.VType.atypeid of
      CSV_UByte: // Byte
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UByte));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SByte: // Shortint
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SByte));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt16: // Word
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt16));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt16: // SmallInt
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt16));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt32: // Cardinal
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt32: // Longint
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Char: // Char
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Char));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_String: // String
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Real: // Real
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Single: // Single
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Double: // Double
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Extended: // Extended
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Bool: // Boolean
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Bool));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Array: // Array
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_ArrItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Record: // Record
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_RecItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Class: // Class
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Class));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
{$IFNDEF NOPOINTERS}
      CSV_Internal: // Pointer
        begin
          try
            SetBoolean(Res, Boolean(GetVarLink(VM_GET(Params,
              0)).CV_Variant.Cv_Int1));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end
{$ENDIF}
    else
      begin
        CastProc := ECustomError;
        Sender.RunError2(Sender, ECustomError, 'Type unsupported');
      end;
    end;
  end
  else
    if (Proc^.Name = 'REAL') or (Proc^.Name = 'SINGLE') or (Proc^.Name =
    'DOUBLE')
    or (Proc^.Name = 'EXTENDED') then
  begin
    case GetVarLink(VM_GET(Params, 0)).CV_Variant.VType.atypeid of
      CSV_UByte: // Byte
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UByte));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SByte: // Shortint
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SByte));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt16: // Word
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt16));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt16: // SmallInt
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt16));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt32: // Cardinal
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt32: // Longint
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt32));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Char: // Char
        begin
          try
            SetReal(Res, Single(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Str));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;

        end;
      CSV_String: // String
        begin
          try
            SetReal(Res, Single(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Str));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Real: // Real
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Real));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Single: // Single
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Single))
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Double: // Double
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Double))
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Extended: // Extended
        begin
          try
            SetReal(Res, (GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Extended));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Bool: // Boolean
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Array: // Array
        begin
          try
            SetReal(Res, Single(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_ArrItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Record: // Record
        begin
          try
            SetReal(Res, Single(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_RecItems));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Class: // Class
        begin
          try
            SetReal(Res, Single(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Class));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
{$IFNDEF NOPOINTERS}
      CSV_Internal: // Pointer
        begin
          try
            SetReal(Res, Single(GetVarLink(VM_GET(Params,
              0)).CV_Variant.Cv_Int1));
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end
{$ENDIF}
    else
      begin
        CastProc := ECustomError;
        Sender.RunError2(Sender, ECustomError, 'Type unsupported');
      end;
    end;
  end
  else
    if (Proc^.Name = 'TCLASS') then
  begin
    case GetVarLink(VM_GET(Params, 0)).CV_Variant.VType.atypeid of
      CSV_UByte: // Byte
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UByte);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SByte: // Shortint
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SByte);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt16: // Word
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt16);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt16: // SmallInt
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt16);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt32: // Cardinal
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt32);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt32: // Longint
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt32);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Char: // Char
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Char);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;

        end;
      CSV_String: // String
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Str);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Real: // Real
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Single: // Single
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Single);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Double: // Double
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Extended: // Extended
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Bool: // Boolean
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Bool);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Array: // Array
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_ArrItems);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Record: // Record
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_RecItems);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Class: // Class
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Class);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
{$IFNDEF NOPOINTERS}
      CSV_Internal: // Pointer
        begin
          try
            Res^.CV_Class := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.Cv_Int1);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end
{$ENDIF}
    else
      begin
        CastProc := ECustomError;
        Sender.RunError2(Sender, ECustomError, 'Type unsupported');
      end;
    end;
  end
  else
    if (Proc^.Name = 'TRECORD') then
  begin
    case GetVarLink(VM_GET(Params, 0)).CV_Variant.VType.atypeid of
      CSV_UByte: // Byte
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UByte);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SByte: // Shortint
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SByte);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt16: // Word
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt16);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt16: // SmallInt
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt16);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt32: // Cardinal
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt32);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt32: // Longint
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt32);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Char: // Char
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Char);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;

        end;
      CSV_String: // String
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Str);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Real: // Real
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Single: // Single
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Single);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Double: // Double
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Extended: // Extended
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Bool: // Boolean
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Bool);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Array: // Array
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_ArrItems);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Record: // Record
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_RecItems);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Class: // Class
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Class);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
{$IFNDEF NOPOINTERS}
      CSV_Internal: // Pointer
        begin
          try
            Res^.CV_RecItems := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.Cv_Int1);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end
{$ENDIF}
    else
      begin
        CastProc := ECustomError;
        Sender.RunError2(Sender, ECustomError, 'Type unsupported');
      end;
    end;
  end
{$IFNDEF NOPOINTERS}
  else
    if (Proc^.Name = 'POINTER') then
  begin
    case GetVarLink(VM_GET(Params, 0)).CV_Variant.VType.atypeid of
      CSV_UByte: // Byte
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UByte);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SByte: // Shortint
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SByte);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt16: // Word
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt16);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt16: // SmallInt
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt16);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_UInt32: // Cardinal
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_UInt32);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_SInt32: // Longint
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_SInt32);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Char: // Char
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Char);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;

        end;
      CSV_String: // String
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Str);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Real: // Real
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Single: // Single
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Single);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Double: // Double
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Extended: // Extended
        begin
          CastProc := ECustomError;
          Sender.RunError2(Sender, ECustomError, 'Invalid typecast');
        end;
      CSV_Bool: // Boolean
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Bool);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Array: // Array
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_ArrItems);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Record: // Record
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_RecItems);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Class: // Class
        begin
          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.CV_Class);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end;
      CSV_Internal: // Pointer
        begin

          try
            Res^.CV_Int1 := Pointer(GetVarLink(VM_GET(Params,
              0)).CV_Variant.Cv_Int1);
          except
            CastProc := ECustomError;
            Sender.RunError2(Sender, ECustomError, 'Invalid Operation');
          end;
        end
    else
      begin
        CastProc := ECustomError;
        Sender.RunError2(Sender, ECustomError, 'Type unsupported');
      end;
    end;
  end
{$ENDIF}
  else
    CastProc := EUnknownIdentifier;
end;

procedure AddTypeCasting(p: TIfPasScript);
begin
  p.AddType('Bool', 'Boolean');
  P.AddFunction(@CastProc, 'function Integer(V: Variant): Integer;', nil);
  P.AddFunction(@CastProc, 'function Longint(V: Variant): LongInt;', nil);
  P.AddFunction(@CastProc, 'function Cardinal(V: Variant): Cardinal;', nil);
  P.AddFunction(@CastProc, 'function String(V: Variant): string;', nil);
  P.AddFunction(@CastProc, 'function Char(V: Variant): string;', nil);
  P.AddFunction(@CastProc, 'function Bool(V: Variant): Boolean;', nil);
  P.AddFunction(@CastProc, 'function Boolean(V: Variant): Boolean;', nil);
  P.AddFunction(@CastProc, 'function Word(V: Variant): Word;', nil);
  P.AddFunction(@CastProc, 'function Byte(V: Variant): Byte;', nil);
  P.AddFunction(@CastProc, 'function ShortInt(V: Variant): ShortInt;', nil);
  P.AddFunction(@CastProc, 'function SmallInt(V: Variant): SmallInt;', nil);
  P.AddFunction(@CastProc, 'function Single(V: Variant): Single;', nil);
  P.AddFunction(@CastProc, 'function Real(V: Variant): Real;', nil);
  P.AddFunction(@CastProc, 'function Double(V: Variant): Double;', nil);
  P.AddFunction(@CastProc, 'function Extended(V: Variant): Extended;', nil);
  P.AddFunction(@CastProc, 'function TClass(V: Variant): TObject;', nil);
  P.AddFunction(@CastProc, 'function TRecord(V: Variant): Record;', nil);
{$IFNDEF NOPOINTERS}
  P.AddType('Pointer', 'ResourcePointer');
  P.AddFunction(@CastProc, 'function Pointer(V: Variant): ResourcePointer;',
    nil);
{$ENDIF}
end;

end.

